{-# LANGUAGE TemplateHaskell,
             FlexibleInstances,
             FlexibleContexts,
             MultiParamTypeClasses,
             DeriveDataTypeable,
             ImpredicativeTypes,
             NoMonomorphismRestriction
 #-}

module AOP.Examples.Fib3 (fib, ppcFib)
where

import AOP.Default

fibTag = $newTag

fibBase :: (Typeable1Monad m) => Function Integer (m Integer) 
fibBase = mkFunction (\n_ -> return 1) fibTag

fibPc = pcCall fibBase `pcAnd` pcArgGT 2

fibAdv proceed n = do f1 <- fibBase # (n-1)
                      f2 <- fibBase # (n-2)
                      return (f1 + f2)
                   
fib = do deploy (niAspect fibPc fibAdv)
         return errorFib 
      where errorFib n = if n < 0 
                         then throwError "Not defined on negative value"
                         else fibBase # n

ppcFib :: (Typeable1Monad m, Typeable1Monad (t m),
           LessGen (Integer -> (NIAOT t m) Integer) (a -> NIAOT t m b)) =>
          ProtectedPC (NIAOT t m) Integer ((NIAOT t m) Integer) (NIAdvice t a b) a b

ppcFib = protectPC fibPc niAdvice

runMemo c = runIdentity (runErrorT (runNIAOT c))

program n = runMemo $ do f <- fib
                         f # n
